package editeur;

import java.awt.Graphics;
import java.awt.Point;
import java.util.List;

public abstract class Rectangulaire {

	protected Point[] points = new Point[2];
	private int xmin, xmax, ymin, ymax;

	public Rectangulaire(List<Point> points) {
		if (points.size() != 2)
			throw new IllegalArgumentException();
		points.toArray(this.points);
		xmin = Math.min(this.points[0].x, this.points[1].x);
		ymin = Math.min(this.points[0].y, this.points[1].y);
		xmax = Math.max(this.points[0].x, this.points[1].x);
		ymax = Math.max(this.points[0].y, this.points[1].y);		
	}

	public void dessine(Graphics g) {
		dessineForme(g, xmin, ymin, xmax - xmin, ymax - ymin);
	}

	protected abstract void dessineForme(Graphics g, int x, int y, int largeur,
			int hauteur);
	
	public String toString() {
		return this.getClass().getSimpleName() + " (" + xmin + "," + ymin + ") (" + xmax + "," + ymax
				+ ")";
	}
}